#ifndef _BACKEND_OPERATIONS_H_
#define _BACKEND_OPERATIONS_H_

#include <stdlib.h>
#include <unistd.h>
#include <gtk/gtk.h>


typedef enum _mms_methods
	{ mms_not_defined = -1, mms_default = 0, mms_tcp, mms_udp, mms_http, mms_asx_http }
mms_methods;

typedef struct _mimms_param
{
	int use_timer;
	int timer;
	gchar *url;
	gchar *output_file;
	mms_methods method;
	gchar *path_to_mimms;
}
mimms_param;

typedef struct _fork_data
{
	int pipes[2];
	pid_t child_pid;
	int return_value;
	GtkWidget *main_window;
	GtkWidget *download_status_window;
}
fork_data;

gboolean preference_load();
gboolean preference_save();

gchar *find_mimms_binary();
gchar *get_mimms_path();
void set_mimms_path(gchar *mimms_path);

gboolean start_download(GtkWidget *widget);
void cancel_download();
void backend_init();
void backend_cleanup();
void mimms_set_method(mms_methods method, GtkWidget *widget, gboolean update_entry_url);
void mimms_use_timer(int status);
void mimms_set_timer(int timer);
void mimms_set_url(gchar *url, GtkWidget *widget);
void mimms_set_output_file(char *filename);

#endif
